<?php
/*
	Copyright(c) 2010 Shift Tech Inc. All Rights Reserved.
 	http://www.shift-tech.jp/
*/

require_once (LIB_PATH.'/common/unitCommon.php');

class extSnsBtn extends unitCommon
{
	//------ ユニット毎に必ず設定しなくてはならない変数 -------//
	var $_table = "extunit_snsbtn"; 			//公開用テーブル名
	var $_tmptable = "extunit_snsbtn_tmp";	//下書き用テーブル名
	var $columns = array(
					array("column"=>"pageu_code","conv"=>"n","tags"=>false),	//ユニット登録コード
					array("column"=>"staticlink","conv"=>"n","tags"=>false),		//静的リンク=1  or 動的リンク＝0
					array("column"=>"url","conv"=>"KVa","tags"=>false),		//対象URL
					array("column"=>"btnlist","conv"=>"KVa","tags"=>false),		//選択ボタン
					array("column"=>"btntype","conv"=>"KVa","tags"=>false),		//ボタンタイプ
					array("column"=>"align","conv"=>"n","tags"=>false),		//表示位置
					array("column"=>"bg_color","conv"=>"n","tags"=>false),		//背景色
					array("column"=>"bdr_type","conv"=>"n","tags"=>false),		//枠線
					array("column"=>"btm_padding","conv"=>"n","tags"=>false),		//下方スペース
					array("column"=>"bg_color_sp","conv"=>"n","tags"=>false),		//背景色
					array("column"=>"bdr_type_sp","conv"=>"n","tags"=>false),		//枠線
					array("column"=>"btm_padding_sp","conv"=>"n","tags"=>false),		//下方スペース
					array("column"=>"use_sp_flg","conv"=>"n","tags"=>false)		//スマホ表示
					);
	var $_btnlist = array('Twitter', 'facebook', 'google+','はてなブックマーク');
	var $_align = array(1=>"left", 2=>"center", 3=>"right");
	
	function extSnsBtn()
	{
		$this->__construct();
	}

	function __construct()
	{
		unitCommon::__construct();
	}
	//-----------------

	//出力データセット処理（必須）
	function setDisplayData() {
		$this->_data = $this->getDetail();
		
		if($this->_data){
			if(defined("SP_FLG") && SP_FLG == SP_FLG_CODE){
				if(is_numeric($this->_data['bg_color_sp'])) $this->_data['bg_color'] = $this->_data['bg_color_sp'];
				if(is_numeric($this->_data['bdr_type_sp'])) $this->_data['bdr_type'] = $this->_data['bdr_type_sp'];
				if(is_numeric($this->_data['btm_padding_sp'])) $this->_data['btm_padding'] = $this->_data['btm_padding_sp'];
			}
			
			$this->_data["share_url"] = CURRENTURL;
			if($this->_data["staticlink"]==1){
				if(is_numeric($this->_data["url"])){
					$this->_data["share_url"] = $this->getPageURL($this->_data["url"]);
				}else{
					$this->_data["share_url"] = $this->_data["url"];
				}
			}
			foreach($this->_btnlist as $k => $v){
				if(preg_match("/^\d{".$k."}1.*$/", $this->_data['btnlist'])){
					$this->_data[str_replace("+","",$v)] = true;
					$this->_data[str_replace("はてなブックマーク","hatena",$v)] = true;
					
				}
			}
			
			$this->_data["align_str"] = $this->_align[$this->_data["align"]];
		}
		
		return $this->_data;
	}

	/*
	 * DBより保存データ取得
	 * 改変可能
	 */
	function getDetail() {
		$sql = "select * from ".$this->getTbl()." where pageu_code = ?";
		if(isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
			$result = $this->db->prepare($sql,$this->_pageu_code);
			if ($result) {
				$rtn = $result->fetchRow(DB_FETCHMODE_ASSOC);
			}
		}
		return $rtn;
	}


	function setDefault()
	{
		$this->data = $this->getDetail();
		if(!$this->data){
			$this->data["staticlink"] = 0;
			$this->data["align"] = 1;
		}
		$this->_form->setDefaults($this->data);
	}

	//フォームエレメントの作成
	function setElements()
	{
		$this->_form->addElement('hidden','pageu_code', $this->_pageu_code,array("id"=>"pageu_code")); //ページコード
		$this->_form->addElement('advcheckbox','staticlink', null, '&nbsp;'._gettext('B_P00929'), array('id'=>'staticlink', 'style'=>'vertical-align: middle'), array(1, 0));
		
		/*
		$select = array(null=>"--"._gettext("B_T00960")."--")+$this->getAllPageSelect();
		$this->_form->addElement('select', 'url', null, $select, array('id'=>'shareurl', 'style'=>'width: 60%; margin-top: 5px;'));
		*/
		$this->_form->addElement('text', 'url', null, array('id'=>'shareurl'));	
		
		$checklist = array();
		foreach($this->_btnlist as $k => $v){
			$checklist[] = $this->_form->createElement('advcheckbox', $k, null, '&nbsp'.$v, array('class'=>'btnlist', 'style'=>'vertical-align: middle'), array(0, 1));
		}
		$this->_form->addGroup($checklist, "btnlist", "", "&nbsp;&nbsp;");
		
		$align = array();
		foreach(array(1=>_gettext("B_P00930"),2=>_gettext("B_P00931"),3=>_gettext("B_P00932")) as $k => $v){
			$align[] = $this->_form->createElement('radio', null, null, '&nbsp'.$v, $k, array('style'=>'vertical-align: middle;'));
		}
		$this->_form->addGroup($align, "align", "", "&nbsp;&nbsp;");
	}

	//フォーム入力エラーチェックの設定
	function setRules()
	{
		$this->_form->applyFilter('__ALL__','trim');
		$this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues,$this->columns); //ルールに従った値変換、タグの除去
		$this->_form->setJsWarnings(_gettext('B_P00472'),'');
		$this->_form->addRule('pageu_code',_gettext('B_P00643'),'required',null,$this->erchk);
		
		if(isset($_POST["btnlist"])){
			$count = count($_POST["btnlist"]);
			$btnlist = implode("", $_POST["btnlist"]);		
			if($btnlist == sprintf("%0{$count}d", 0)){
				$this->_form->setElementError('btnlist', _gettext("B_P00933", _gettext("B_T00959")));
			}
		}
		if(isset($_POST["staticlink"]) && $_POST["staticlink"] == 1){
			$this->_form->addRule('url', _gettext("B_P00933", _gettext("B_T00960")), 'required', null, $this->erchk);
			
			if(!(preg_match("/^".str_replace("/", "\/",WWW).".*$/", $_POST["url"]) || preg_match("/^".str_replace("/", "\/",WWW_SSL).".*$/", $_POST["url"]))){
				$this->_form->setElementError("url","・共有リンク先に外部サイトのURLは設定できません");
			}
		}
		$this->_form->addRule('url', '・共有リンク先のURLが正しくありません', 'regex', "/^(https?)(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)$/", $this->erchk);
		
	}

	function getPageURL($id = null){
		if(!is_numeric($id)) return null;
		
		$sql ="SELECT
				p.pidx_title
				,p.pidx_url
				,p.pidx_code
				,p.pidx_order
				,p.pidx_view
				,p2.pidx_view as pidx_view2
				,s.sidx_title
				,s.sidx_dir
				,s.sidx_code
				,s.sidx_order
				,s.sidx_view
				,ps.sidx_title as sidx_title2
				,ps.sidx_dir as sidx_dir2
				,ps.sidx_code as sidx_code2
				,ps.sidx_view as sidx_view2
				,CASE WHEN ps.sidx_order IS NULL THEN s.sidx_order ELSE ps.sidx_order END as ps_sidx_order
				,CASE WHEN ps.sidx_order IS NULL THEN 0 ELSE 1 END as parent
				FROM tbl_page_idx_tmp as p
				LEFT JOIN tbl_page_idx as p2
				ON p.pidx_code = p2.pidx_code
				JOIN tbl_section_idx_tmp as s
				ON s.sidx_code = p.pidx_sidx_code AND s.sidx_active=1 AND (s.sidx_extmodule_code <> 1000 OR s.sidx_extmodule_code IS NULL)
				LEFT JOIN tbl_section_idx_tmp as ps
				ON ps.sidx_code = s.sidx_parent_sidx_code AND ps.sidx_active=1 AND (ps.sidx_extmodule_code <> 1000 OR ps.sidx_extmodule_code IS NULL)
				WHERE p.pidx_active = 1 AND p.pidx_code = ?
				ORDER BY ps_sidx_order, parent, ps.sidx_code,  s.sidx_order, s.sidx_code, p.pidx_order, p.pidx_code DESC";
		
		$result = $this->db->prepare($sql, array($id));
		$data=array();
		if($result){
			$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
			if(empty($row["sidx_code2"]) && !is_numeric($row["sidx_code2"])){
				$sidx_dir =  $row["sidx_dir"];
				$sidx_title =  $row["sidx_title"];
				$sidx_view =  $row["sidx_view"];
				$cat_dir = null;
			}else{//ローカルの時
				$sidx_dir = $row["sidx_dir2"];
				$sidx_title = $row["sidx_title2"]." > ".$row["sidx_title"];
				$sidx_view =  $row["sidx_view2"];
				$cat_dir = $row["sidx_dir"];
			}
			$page = $row["pidx_url"];
			return pageView::getSiteURL($sidx_dir, $cat_dir, $page, $BINGOTOPURL == WWW_SSL, false, false);
		}
		return $data;
	}
	
	function getAllPageSelect(){
		$sql ="SELECT
				p.pidx_title
				,p.pidx_url
				,p.pidx_code
				,p.pidx_order
				,p.pidx_view
				,p2.pidx_view as pidx_view2
				,s.sidx_title
				,s.sidx_dir
				,s.sidx_code
				,s.sidx_order
				,s.sidx_view
				,ps.sidx_title as sidx_title2
				,ps.sidx_dir as sidx_dir2
				,ps.sidx_code as sidx_code2
				,ps.sidx_view as sidx_view2
				,CASE WHEN ps.sidx_order IS NULL THEN s.sidx_order ELSE ps.sidx_order END as ps_sidx_order
				,CASE WHEN ps.sidx_order IS NULL THEN 0 ELSE 1 END as parent
				FROM tbl_page_idx_tmp as p
				LEFT JOIN tbl_page_idx as p2
				ON p.pidx_code = p2.pidx_code
				JOIN tbl_section_idx_tmp as s
				ON s.sidx_code = p.pidx_sidx_code AND s.sidx_active=1 AND (s.sidx_extmodule_code <> 1000 OR s.sidx_extmodule_code IS NULL)
				LEFT JOIN tbl_section_idx_tmp as ps
				ON ps.sidx_code = s.sidx_parent_sidx_code AND ps.sidx_active=1 AND (ps.sidx_extmodule_code <> 1000 OR ps.sidx_extmodule_code IS NULL)
				WHERE p.pidx_active = 1
				ORDER BY ps_sidx_order, parent, ps.sidx_code,  s.sidx_order, s.sidx_code, p.pidx_order, p.pidx_code DESC";
		
		$result = $this->db->query($sql);
		$data=array();
		if($result){
			$current_sidx = 0;
			while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
				if(empty($row["sidx_code2"]) && !is_numeric($row["sidx_code2"])){
					$sidx_dir =  $row["sidx_dir"];
					$sidx_title =  $row["sidx_title"];
					$sidx_view =  $row["sidx_view"];
					$cat_dir = null;
				}else{//ローカルの時
					$sidx_dir = $row["sidx_dir2"];
					$sidx_title = $row["sidx_title2"]." > ".$row["sidx_title"];
					$sidx_view =  $row["sidx_view2"];
					$cat_dir = $row["sidx_dir"];
				}
				if($sidx_view=="-2"){
					$row["pidx_title"] .= "（非公開）";
				}else{
					if(empty($row["pidx_view2"]) && $row["pidx_view2"]!=0){
						$pidx_view = $row["pidx_view"];
					}else{
						$pidx_view = $row["pidx_view2"];
					}
					switch($pidx_view){
						case "-2":
							$row["pidx_title"] .= "（非公開）";
							break;
						case "-1":
							$row["pidx_title"] .= "（却下）";
							break;
						case "0":
							$row["pidx_title"] .= "（新規）";
							break;
						case "1":
							$row["pidx_title"] .= "（申請中）";
							break;
						case "2":
							break;
					}
				}
				$page = $row["pidx_url"];
				//$data[pageView::getSiteURL($sidx_dir, $cat_dir, $page, $BINGOTOPURL == WWW_SSL, false, false)] = $sidx_title." > ".$row["pidx_title"];
				$data[$row["pidx_code"]] = $sidx_title." > ".$row["pidx_title"];
			}
		}
		return $data;
	}

	//データ下書き保存処理
	function doSave($post)
	{
		$record = null;
		foreach($this->columns as $val) {
			if($post[$val["column"]]!=null){
				$record[$val["column"]] = $post[$val["column"]];
			} else {
				$record[$val["column"]] = null;
			}
		}	
		$record["btnlist"] = implode("", $record["btnlist"]);
		
		//既存データがあるか確認
		$old_data = $this->getDetail();
		$this->db->query('BEGIN');
		//保存処理開始
		if(is_array($old_data)&& count($old_data)>0) {
			//更新
			if(!$this->db->update($this->getTbl(),$record, "pageu_code=".$record["pageu_code"])) {
				$this->db->query('ROLLBACK');
				return _gettext('B_P00209');
			}
		} else { //新規
			if(!$this->db->insert($this->getTbl(),$record)) {
				$this->db->query('ROLLBACK');
				return _gettext('B_P00209');
			}
		}
		$this->db->query('COMMIT');
		return null;
	}
}


?>